
async function walkNode(node, callback) {
	if (node.children && node.children.length > 0) {
		for (let childNode of node.children) {
			await callback(childNode, node);
			const result = await walkNode(childNode, callback);
			if (result === true) {
				break;
			}
		}
	}
}

async function walkObject(obj, callback) {
	if (typeof obj === "object") {
		for (let key of Object.keys(obj)) {
			const value = obj[key];
			await callback(key, value, obj);
			const result = await walkObject(value, callback);
			if (result === true) {
				break;
			}
		}
	}
}
function trimCustom(str) {
	var result;
	result = str.replace(/(^\s+)|(\s+$)/g, "");
	result = result.replace(/\s/g, "");
	return result;
}
module.exports = {
	walkNode,
	walkObject,
	trimCustom
}